#include <Arduino.h>

volatile bool rx_done = true;

void recv_cb(rui_lora_p2p_recv_t data)
{
	rx_done = true;
	if (data.BufferSize == 0)
	{
		Serial.println("Empty buffer.");
		return;
	}
	char buff[92];
	sprintf(buff, "income %s, length: %d, RSSI: %d, SNR: %d", data.Buffer, data.BufferSize, data.Rssi, data.Snr);
	Serial.println(buff);
}

void send_cb(void)
{
	// api.lorawanwan.precv(65535);
	Serial.printf("P2P TX done\n");
}

void setup()
{
	Serial.begin(115200);
	delay(5000);

	// Set LoRa P2P configuration
	api.lorawan.nwm.set(0);

	/// \todo this should be done by AT commands!
	// AT+P2P=916000000:7:0:1:8:5
	api.lorawan.pfreq.set(916000000);
	api.lorawan.psf.set(7);
	api.lorawan.pbw.set(0);
	api.lorawan.pcr.set(1);
	api.lorawan.ppl.set(8);
	api.lorawan.ptp.set(5);

	api.lorawan.registerPRecvCallback(recv_cb);
	api.lorawan.registerPSendCallback(send_cb);
	Serial.printf("Set TX %s\r\n", api.lorawan.precv(65533) ? "Success" : "Fail");
}

uint8_t counter = 0;

void loop()
{
	// uint8_t payload[] = "payload";

	if (rx_done)
	{
		rx_done = false;

		char payload[18];
		sprintf(payload, "Payload_TX_%02X", counter);
		counter++;

		bool send_result = false;
		while (!send_result)
		{
			send_result = api.lorawan.psend(14, (uint8_t *)payload);
			Serial.printf("Sent =   %s\r\n", send_result ? "Success" : "Fail");
			if (send_result)
			{
				// Serial.printf("Pause for receive\n");
				// delay(2000);
			}
		}
	}
}